﻿using Sample.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Sample.Controllers
{
    public class HomeController : Controller
    {
        //
        // GET: /Home/

        public ActionResult Index()
        {
            var MasterData = OrderRepository.GetAllRecords();
            ViewBag.dataSource1 = MasterData;

            var Name = OrderRepository.GetAllRecords().Select(p => new { text = p.CustomerID, value = p.CustomerID }).Distinct().ToList();
            ViewBag.name = Name;

            var Country = OrderRepository.GetAllRecords().Select(p => new { text = p.ShipCity, value = p.ShipCity }).Distinct().ToList();            
            ViewBag.country = Country;

            return View();
        }
        public ActionResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords();
            return Json(value, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Insert(EditableOrder value)
        {
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords();
            return Json(value, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Delete(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Data(DataManager dm)
        {
            IEnumerable data = OrderRepository.GetAllRecords().ToList();
            DataOperations operation = new DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                data = operation.PerformSorting(data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                data = operation.PerformWhereFilter(data, dm.Where, dm.Where[0].Operator);
            }
            int count = data.Cast<EditableOrder>().Count();
            if (dm.Skip != 0)
            {
                data = operation.PerformSkip(data, dm.Skip);
            }
            if (dm.Take != 0)
            {
                data = operation.PerformTake(data, dm.Take);
            }
            return Json(new { result = data, count = count });
        }
        public ActionResult DataSource(string titleValue)
        {

          var userTemplates = OrderRepository.GetAllRecords().Where(c => c.CustomerID == titleValue).OrderBy(a => a.ShipCity).Select(a => new { value = a.ShipCity, text = a.ShipCity }).Distinct().ToList();
           
          return Json(userTemplates, JsonRequestBehavior.AllowGet);
        }
    }
}
